
/*

libwindow fr Cim (GNU/Simula)
av Fredrik Roubert 1996
 
Version 0.1 (960306)

*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>


static char	white_bits[]={	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
				0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
				0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
				0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
				0x00, 0x00, 0x00, 0x00},
		black_bits[]={	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
				0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
				0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
				0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
				0xff, 0xff, 0xff, 0xff},
		grey_bits[]={	0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa,
				0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55,
				0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55,
				0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa,
				0x55, 0x55, 0xaa, 0xaa};

Display		*DISP;
Window		WIN=0;
int		HEIGHT,WIDTH,XPOS=0,YPOS=0,COLOUR=0,_fast_mode,_fixed_size;
GC		WINGC;
unsigned char	Key_Code[21];
Pixmap		greyPM,whitePM,blackPM;
XGCValues	_gcvals;

int	TheHeight();
void	clearscreen();
void	initgraphics();
void	closegraphics();
void	writestring();
void	setposition();
void	lineto();
void	setcolour();
void	getposition();
void	wait_for_event();
void	get_key_code();
void	set_fill_colour();
void	draw_rectangle();
void	fill_rectangle();
void	draw_circle();
void	fill_circle();
void	set_line_width();
void	set_window_name();
void	set_fast_mode();
void	set_normal_mode();
int	events_available();


int TheHeight(void)
{
	int	x,y,w,h,bw,d;
	Window	root;

	if (_fixed_size)
		return(HEIGHT);
	else
	{
		XGetGeometry(DISP,WIN,&root,&x,&y,&w,&h,&bw,&d);
		return(h);
	}
}

void clearscreen(void)
{
	XClearWindow(DISP,WIN);
	if(!_fast_mode)
		XFlush(DISP);
}

void initgraphics(int W, int H)
{
	XEvent		XEV;
	XWMHints	wmhints;
	XSizeHints	sizehints;
	int		screen_depth;

	_fast_mode=0;
	_fixed_size=1;

	DISP=XOpenDisplay(0);

	WIDTH=(W<=1000?(W<10?10:W):1000);
	HEIGHT=(H<=860?(H<10?10:H):860);

	WIN=XCreateSimpleWindow(
		DISP,DefaultRootWindow(DISP),
		200,2,WIDTH,HEIGHT,3,
		BlackPixel(DISP,DefaultScreen(DISP)),
		WhitePixel(DISP,DefaultScreen(DISP))
	);

	WINGC=XDefaultGC(DISP,DefaultScreen(DISP));
	screen_depth=DefaultDepth(DISP,DefaultScreen(DISP));
	whitePM=XCreatePixmapFromBitmapData(
		DISP,WIN,white_bits,16,16,
		BlackPixel(DISP,DefaultScreen(DISP)),
		WhitePixel(DISP,DefaultScreen(DISP)),
		screen_depth
	);
	blackPM=XCreatePixmapFromBitmapData(
		DISP,WIN,black_bits,16,16,
		BlackPixel(DISP,DefaultScreen(DISP)),
		WhitePixel(DISP,DefaultScreen(DISP)),
		screen_depth
	);
	greyPM=XCreatePixmapFromBitmapData(
		DISP,WIN,grey_bits,16,16,
		BlackPixel(DISP,DefaultScreen(DISP)),
		WhitePixel(DISP,DefaultScreen(DISP)),
		screen_depth
	);

	XSetFillStyle(DISP,WINGC,FillTiled);
	XSetTile(DISP,WINGC,blackPM);

	wmhints.flags=InputHint;
	wmhints.input=1;
	XSetWMHints(DISP,WIN,&wmhints);

	sizehints.flags=(PMinSize|PMaxSize);
	sizehints.min_width=sizehints.max_width=WIDTH;
	sizehints.min_height=sizehints.max_height=HEIGHT;
	XSetWMNormalHints(DISP,WIN,&sizehints);

	XSetForeground(DISP,WINGC,BlackPixel(DISP,DefaultScreen(DISP)));
	XSelectInput(DISP,WIN,ExposureMask);
	XMapWindow(DISP,WIN);
	XNextEvent(DISP,&XEV);
	XSelectInput(DISP,WIN,(ButtonPressMask|KeyPressMask|ExposureMask));

	XFlush(DISP);
	setcolour(1);
	XPOS=0;
	YPOS=0;
	while(XCheckMaskEvent(DISP,ExposureMask,&XEV));
}

void closegraphics(void)
{
	XCloseDisplay(DISP);
}

void writestring(char *str, int n)
{
	XDrawImageString(DISP,WIN,WINGC,XPOS,YPOS-1,str,n);
	XPOS+=n*6;

	if(!_fast_mode)
		XFlush(DISP);
}

void setposition(int X, int Y)
{
	XPOS=X;
	YPOS=TheHeight()-Y;
}

void lineto(int X, int Y)
{
	XDrawLine(DISP,WIN,WINGC,XPOS,YPOS,X,TheHeight()-Y);
	if(!_fast_mode)
		XFlush(DISP);
	XPOS=X;
	YPOS=TheHeight()-Y;
}

void setcolour(int MODE)
{
	switch(MODE){
		case 1:
			XSetFunction(DISP,WINGC,GXcopy);
			break;
		case 2:
			XSetFunction(DISP,WINGC,GXclear);
			break;
		default:
			XSetFunction(DISP,WINGC,GXxor);
	}
}

void getposition(int *X, int *Y)
{
	*X=XPOS;
	*Y=TheHeight()-YPOS;
}

void wait_for_event(	int *Event_Type, int *X, int *Y,
			int *Which_Button, int *Key_Code_Length)
{
	XEvent	THE_EVENT;
	Bool	Continue;

	Continue=True;
	while(Continue)
	{
		XNextEvent(DISP,&THE_EVENT);
		switch(THE_EVENT.type)
		{
			case KeyPress:
				*Key_Code_Length=XLookupString(
						(XKeyEvent *)&THE_EVENT,
						Key_Code,20,None,None
					);
				if(*Key_Code_Length)
				{
					*Event_Type=0;
					Continue=False;
				}
				break;

			case ButtonPress:
				*X=THE_EVENT.xbutton.x;
				*Y=TheHeight()-THE_EVENT.xbutton.y;
				switch(THE_EVENT.xbutton.button)
				{
					case Button1:
						*Which_Button=1;
						break;

					case Button2:
						*Which_Button=2;
						break;

					case Button3:
						*Which_Button=3;
				}
				*Event_Type=1;
				Continue=False;
				break;

			case Expose:
				*Event_Type=2;
				Continue=False;
		}
	}
}

void get_key_code(int place, int *code)
{
	*code=Key_Code[place-1];
}

void set_fill_colour(int colour)
{
	switch(colour)
	{
		case 0:
			XSetTile(DISP,WINGC,blackPM);
			break;
		case 1:
			XSetTile(DISP,WINGC,greyPM);
			break;
		case 2:
			XSetTile(DISP,WINGC,whitePM);
	}
}

void draw_rectangle(int width, int height)
{
	XDrawRectangle(DISP,WIN,WINGC,XPOS,YPOS,width,height);
	if(!_fast_mode)
		XFlush(DISP);
}

void fill_rectangle(int width, int height)
{
	XFillRectangle(DISP,WIN,WINGC,XPOS,YPOS,width,height);
	if(!_fast_mode)
		XFlush(DISP);
}

void draw_circle(int radius)
{
	XDrawArc(
		DISP,WIN,WINGC,XPOS-radius,YPOS-radius,
		2*radius,2*radius,0,360*64
	);
	if(!_fast_mode)
		XFlush(DISP);
}

void fill_circle(int radius)
{
	XFillArc(
		DISP,WIN,WINGC,XPOS-radius,YPOS-radius,
		2*radius,2*radius,0,360*64
	);
	if(!_fast_mode)
		XFlush(DISP);
}

void set_line_width(int w)
{
	XSetLineAttributes(DISP,WINGC,w,LineSolid,CapButt,JoinRound);
	if(!_fast_mode)
		XFlush(DISP);
}

void set_window_name(char *name)
{
	XStoreName(DISP,WIN,name);
	if(!_fast_mode)
		XFlush(DISP);
}

void set_fast_mode(void)
{
	_fast_mode=1;
}

void set_normal_mode(void)
{
	_fast_mode=0;
	XFlush(DISP);
}

int events_available(void)
{
	return(XPending(DISP));
}

int new_pixmap(int width, int height)
{
	if(WIN!=0)
		return(
			XCreatePixmap(
				DISP,WIN,width,height,
				DefaultDepth(DISP,DefaultScreen(DISP))
			)
		);
	else
		return(0);
}

void draw_pixmap(int pixmap, int x, int y, unsigned int w, unsigned int h)
{
	XCopyArea(DISP,pixmap,WIN,WINGC,0,0,w,h,x,y);
	if(!_fast_mode)
		XFlush(DISP);
}

void draw_pixmap_point(int pixmap, int x, int y)
{
	XGetGCValues(DISP,WINGC,GCFunction,&_gcvals);
	XSetFunction(DISP,WINGC,GXset);
	XDrawPoint(DISP,pixmap,WINGC,x,y);
	XSetFunction(DISP,WINGC,_gcvals.function);
}

void erase_pixmap_point(int pixmap, int x, int y)
{
	XGetGCValues(DISP,WINGC,GCFunction,&_gcvals);
	XSetFunction(DISP,WINGC,GXclear);
	XDrawPoint(DISP,pixmap,WINGC,x,y);
	XSetFunction(DISP,WINGC,_gcvals.function);
}

void clear_pixmap(int pixmap, int w, int h)
{
	XGetGCValues(DISP,WINGC,(GCFunction|GCTile),&_gcvals);
	XSetFunction(DISP,WINGC,GXclear);
	XSetTile(DISP,WINGC,blackPM);
	XFillRectangle(DISP,pixmap,WINGC,0,0,w,h);
	XSetFunction(DISP,WINGC,_gcvals.function);
	XSetTile(DISP,WINGC,_gcvals.tile);
}

void free_pixmap(int pixmap)
{
	XFreePixmap(DISP,pixmap);
}

int read_bitmap_file(char *filename, int *width, int *height)
{
	int	w,h,x,y;
	Pixmap	p1,p2;

	if(XReadBitmapFile(DISP,WIN,filename,&w,&h,&p1,&x,&y)==BitmapSuccess)
	{
		*width=w;
		*height=h;
		p2=XCreatePixmap(
			DISP,WIN,w,h,
			DefaultDepth(DISP,DefaultScreen(DISP))
		);
		XCopyPlane(DISP,p1,p2,WINGC,0,0,w,h,0,0,1);
		XFreePixmap(DISP,p1);
		return(p2);
	}
	else
		return(0);
}

